#property copyright "Kruger"

// Kicks in when position reaches at least TrailingStop pips of profit.

extern string LabelPips = "Value in Pips";
extern double TrailingStart = 10; 
extern double TrailingStop = 5;
 
double res;

int init()
{
   return(0);
}
 
int deinit()
{
   return(0);
}
 
int start()
{

  for (int i = 0; i < OrdersTotal(); i++) 
  {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true)
      
      double vbid    = MarketInfo(OrderSymbol(),MODE_BID);
      double vask    = MarketInfo(OrderSymbol(),MODE_ASK);
      double vpoint  = MarketInfo(OrderSymbol(),MODE_POINT);
      double PointValue = vpoint*10;
      
     if (OrderType() == OP_BUY)
      {
         if (vbid - OrderOpenPrice() > TrailingStart*PointValue)
         {
            if ((OrderStopLoss() < vbid - TrailingStop*PointValue) || (OrderStopLoss() == 0))
            {
               if (!OrderModify(OrderTicket(), OrderOpenPrice(), vbid - TrailingStop*PointValue, OrderTakeProfit(), OrderExpiration(), clrNONE))
                  if(!res) 
               Print("Error in OrderModify. Error code=",GetLastError()); 
            else 
               Print("Order modified successfully."); 
            }
         }            
      }
      else if (OrderType() == OP_SELL)
      {
         if (OrderOpenPrice() - vask > TrailingStart*PointValue)
         {
            if ((OrderStopLoss() > vask + TrailingStop*PointValue) || (OrderStopLoss() == 0))
            {
               if (!OrderModify(OrderTicket(), OrderOpenPrice(), vask + TrailingStop*PointValue, OrderTakeProfit(), OrderExpiration(), clrNONE))
                  if(!res) 
               Print("Error in OrderModify. Error code=",GetLastError()); 
            else 
               Print("Order modified successfully."); 
            }
         }      
      }   
	}
 
   return(0);
}